process Chronometer =
     ( ? event StartStop;
         event Reset;
         event Tick;
       ! integer disp1;
         integer disp2;
     )
     unsafe
   (| Chrono :: Automaton_Chrono{}
    | Display :: Automaton_Display{}
    | seconds ^= tmp_seconds ^= tmp_minutes ^= minutes ^= Tick
    | disp1 := tmp_seconds
    | disp2 := tmp_minutes
    |)
   where 
   shared integer seconds;
   shared integer minutes;
   shared boolean run;
   shared integer tmp_seconds;
   shared integer tmp_minutes;
   label Chrono; 
   process Automaton_Chrono =
        ( )%**ERROR: Signal _trigger not declared in the process interface
        %
      (| case _cUrReNtStAtE in
         {#Stop}: (| State_Stop{} |)
         {#Start}: (| State_Start{} |)
         end 
       | __ST_0_StrongTransition1_P_0 := (when StartStop) when (_zNeXtStAtE=#Stop)
       | __ST_1_StrongTransition2_P_0 := (when StartStop) when (_zNeXtStAtE=#Start)
       | _cUrReNtStAtE := (#Start when __ST_0_StrongTransition1_P_0) default (#Stop when __ST_1_StrongTransition2_P_0) default _zNeXtStAtE
       | _cUrReNtStAtE ^= _trigger%**ERROR: Identifier not declared : _trigger
         %
       | _nExTsTaTe := _cUrReNtStAtE
       | _pReViOuSsTaTe := _cUrReNtStAtE$ init #Stop
       | _zNeXtStAtE := _nExTsTaTe$ init #Stop
       |)
      where 
      process State_Stop =
           ( )
         (| seconds ::= (0 when (^Reset)) default (seconds$ init 0)
          | minutes ::= (0 when (^Reset)) default (minutes$ init 0)
          | run ::= false
          |)
      %State_Stop%; 
      process State_Start =
           ( )
         (| milliseconds := ((milliseconds$ init 0)+1) modulo 100
          | seconds ::= if milliseconds<(milliseconds$ init 0) then (1+(seconds$ init 0)) modulo 60 else (seconds$ init 0)
          | minutes ::= if seconds<(seconds$ init 0) then (1+(minutes$ init 0)) modulo 60 else (minutes$ init 0)
          | run ::= true
          |)
         where 
         integer milliseconds;
         end
      %State_Start%; 
      event __ST_0_StrongTransition1_P_0;
      event __ST_1_StrongTransition2_P_0;
      type _nAmEsTaTeTyPe = enum (Stop, Start);
      _nAmEsTaTeTyPe _cUrReNtStAtE;
      _nAmEsTaTeTyPe _nExTsTaTe, _pReViOuSsTaTe, _zNeXtStAtE;
      end
   %Automaton_Chrono%; 
   label Display; 
   process Automaton_Display =
        ( )%**ERROR: Signal _trigger not declared in the process interface
        %
      (| case _cUrReNtStAtE in
         {#Time}: (| State_Time{} |)
         {#Lap}: (| State_Lap{} |)
         end 
       | __WT_0_WeakTransition1_P_0 := (when (Reset and run)) when (_cUrReNtStAtE=#Time)
       | __WT_1_WeakTransition2_P_0 := (when Reset) when (_cUrReNtStAtE=#Lap)
       | _cUrReNtStAtE := _zNeXtStAtE
       | _cUrReNtStAtE ^= _trigger%**ERROR: Identifier not declared : _trigger
         %
       | _nExTsTaTe := (#Lap when __WT_0_WeakTransition1_P_0) default (#Time when __WT_1_WeakTransition2_P_0) default _cUrReNtStAtE
       | _pReViOuSsTaTe := _cUrReNtStAtE$ init #Time
       | _zNeXtStAtE := _nExTsTaTe$ init #Time
       |)
      where 
      process State_Time =
           ( )
         (| tmp_seconds ::= seconds
          | tmp_minutes ::= minutes
          |)
      %State_Time%; 
      process State_Lap =
           ( )
         (| tmp_seconds ::= tmp_seconds$ init 0
          | tmp_minutes ::= tmp_minutes$ init 0
          |)
      %State_Lap%; 
      event __WT_0_WeakTransition1_P_0;
      event __WT_1_WeakTransition2_P_0;
      type _nAmEsTaTeTyPe = enum (Time, Lap);
      _nAmEsTaTeTyPe _cUrReNtStAtE;
      _nAmEsTaTeTyPe _nExTsTaTe, _pReViOuSsTaTe, _zNeXtStAtE;
      end
   %Automaton_Display%; 
   end
%Chronometer%; 
